Futures
Concurrency
Collaboration diagram for Futures:

## Classes

class | std::future< _Res >
struct | std::is_error_code_enum< future_errc >
class | std::promise< _Res >
class | std::shared_future< _Res >

## Enumerations

enum class | std::future_errc { future_already_retrieved , promise_already_satisfied , no_state , broken_promise }
enum class | std::future_status { ready , timeout , deferred }
enum class | std::launch { async , deferred }

## Functions

| std::__basic_future< _Res >::__basic_future (const shared_future< _Res > &) noexcept
| std::__basic_future< _Res >::__basic_future (future< _Res > &&) noexcept
| std::__basic_future< _Res >::__basic_future (shared_future< _Res > &&) noexcept
template<typename _Fn , typename... _Args>
future< __async_result_of< _Fn, _Args... > > | std::async (_Fn &&__fn, _Args &&... __args)
template<typename _Fn , typename... _Args>
future< __async_result_of< _Fn, _Args... > > | std::async (launch __policy, _Fn &&__fn, _Args &&... __args)
const error_category & | std::future_category () noexcept
error_code | std::make_error_code (future_errc __errc) noexcept
error_condition | std::make_error_condition (future_errc __errc) noexcept
constexpr launch | std::operator& (launch __x, launch __y) noexcept
launch & | std::operator&= (launch &__x, launch __y) noexcept
constexpr launch | std::operator^ (launch __x, launch __y) noexcept
launch & | std::operator^= (launch &__x, launch __y) noexcept
constexpr launch | std::operator| (launch __x, launch __y) noexcept
launch & | std::operator|= (launch &__x, launch __y) noexcept
constexpr launch | std::operator~ (launch __x) noexcept
template<typename _Fun , typename _Signature = typename __function_guide_helper<decltype(&_Fun::operator())>::type>
| std::packaged_task (_Fun) -> packaged_task< _Signature >
template<typename _Res , typename... _ArgTypes>
| std::packaged_task (_Res(*)(_ArgTypes...)) -> packaged_task< _Res(_ArgTypes...)>
shared_future< _Res > | std::future< _Res >::share () noexcept
shared_future< _Res & > | std::future< _Res & >::share () noexcept
shared_future< void > | std::future< void >::share () noexcept
template<typename _Res , typename... _ArgTypes>
void | std::swap (packaged_task< _Res(_ArgTypes...)> &__x, packaged_task< _Res(_ArgTypes...)> &__y) noexcept
template<typename _Res >
void | std::swap (promise< _Res > &__x, promise< _Res > &__y) noexcept

## Detailed Description

Futures and promises provide support for retrieving the result from an asynchronous function, e.g. one that is running in another thread. A `std::future` represents an asynchronous result that will become ready at some later time. A consumer can wait on a future until the result is ready to be accessed.

Since
  C++11

## Enumeration Type Documentation

## future_errc

enum std::future_errc

strong

Error code for futures.

Definition at line 72 of file future.

## future_status

enum std::future_status

strong

Status code for futures.

Definition at line 184 of file future.

## launch

enum std::launch

strong

Launch code for futures.

Definition at line 147 of file future.

## Function Documentation

## async() [1/2]

template<typename _Fn , typename... _Args>

future< __async_result_of< _Fn, _Args... > > std::async | ( | _Fn && | __fn,
|  | _Args &&... | __args
| ) |  |

inline

async, potential overload

Definition at line 1826 of file future.

## async() [2/2]

template<typename _Fn , typename... _Args>

future< __async_result_of< _Fn, _Args... > > std::async | ( | launch | __policy,
|  | _Fn && | __fn,
|  | _Args &&... | __args
| ) |  |

async

Definition at line 1792 of file future.

## future_category()

const error_category& std::future_category | ( |  | ) |

noexcept

Points to a statically-allocated object derived from error_category.

## make_error_code()

error_code std::make_error_code | ( | future_errc | __errc | ) |

inline noexcept

Overload of make_error_code for `future_errc`.

Definition at line 92 of file future.

## make_error_condition()

error_condition std::make_error_condition | ( | future_errc | __errc | ) |

inline noexcept

Overload of make_error_condition for `future_errc`.

Definition at line 98 of file future.

## swap()

template<typename _Res , typename... _ArgTypes>

void std::swap | ( | packaged_task< _Res(_ArgTypes...)> & | __x,
|  | packaged_task< _Res(_ArgTypes...)> & | __y
| ) |  |

inline noexcept

swap

Definition at line 1660 of file future.